"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var parse_1 = require("../utils/parse");
var OrderByPipe = (function () {
    function OrderByPipe() {
        this.$parse = parse_1.Parse();
    }
    OrderByPipe.prototype.transform = function (array) {
        var _this = this;
        var attrs = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            attrs[_i - 1] = arguments[_i];
        }
        // generate an array of predicate-objects contains
        // property getter, and descending indicator
        var predicates = attrs.map(function (pred) {
            var descending = pred.charAt(0) === '-' ? -1 : 1;
            pred = pred.replace(/^-/, '');
            return {
                getter: function (o) { return _this.$parse(pred)(o); },
                descend: descending
            };
        });
        // schwartzian transform idiom implementation. aka: "decorate-sort-undecorate"
        return array.map(function (item) {
            return {
                src: item,
                compareValues: predicates.map(function (predicate) { return predicate.getter(item); })
            };
        })
            .sort(function (o1, o2) {
            var i = -1, result = 0;
            while (++i < predicates.length) {
                if (o1.compareValues[i] < o2.compareValues[i])
                    result = -1;
                if (o1.compareValues[i] > o2.compareValues[i])
                    result = 1;
                if (result *= predicates[i].descend)
                    break;
            }
            return result;
        })
            .map(function (item) { return item.src; });
    };
    return OrderByPipe;
}());
OrderByPipe = __decorate([
    core_1.Pipe({
        name: 'orderBy'
    }),
    __metadata("design:paramtypes", [])
], OrderByPipe);
exports.OrderByPipe = OrderByPipe;
//# sourceMappingURL=order-by.pipe.js.map