"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var utils_1 = require("../utils/utils");
var FuzzyPipe = (function () {
    function FuzzyPipe() {
    }
    FuzzyPipe.prototype.transform = function (collection, search, csensitive) {
        var _this = this;
        if (csensitive === void 0) { csensitive = false; }
        if (!utils_1.isArray(collection)) {
            collection = utils_1.toArray(collection);
        }
        if (!utils_1.isArray(collection) || utils_1.isUndefined(search)) {
            return collection;
        }
        if (!csensitive) {
            search = search.toLowerCase();
        }
        return collection.filter(function (elm) {
            if (utils_1.isString(elm)) {
                if (!csensitive) {
                    elm = elm.toLowerCase();
                }
                return utils_1.hasApproxPattern(elm, search);
            }
            return utils_1.isObject(elm) ? _this.hasApproximateKey(elm, search, csensitive) : false;
        });
    };
    FuzzyPipe.prototype.hasApproximateKey = function (object, search, csensitive) {
        if (csensitive === void 0) { csensitive = false; }
        return Object.keys(object).some(function (elm) {
            var prop = object[elm];
            if (!utils_1.isString(prop)) {
                return false;
            }
            if (!csensitive) {
                prop = prop.toLowerCase();
            }
            return utils_1.hasApproxPattern(prop, search);
        });
    };
    return FuzzyPipe;
}());
FuzzyPipe = __decorate([
    core_1.Pipe({
        name: 'fuzzy'
    }),
    __metadata("design:paramtypes", [])
], FuzzyPipe);
exports.FuzzyPipe = FuzzyPipe;
//# sourceMappingURL=fuzzy.pipe.js.map